Package helma.scripting.rhino.extensions

# Class XmlRpcObject

java.lang.Object
org.mozilla.javascript.ScriptableObject
org.mozilla.javascript.IdScriptableObject
org.mozilla.javascript.BaseFunction
helma.scripting.rhino.extensions.XmlRpcObject

All Implemented Interfaces:
  `Serializable`, `org.mozilla.javascript.Callable`, `org.mozilla.javascript.ConstProperties`, `org.mozilla.javascript.Constructable`, `org.mozilla.javascript.debug.DebuggableObject`, `org.mozilla.javascript.Function`, `org.mozilla.javascript.IdFunctionCall`, `org.mozilla.javascript.Scriptable`, `org.mozilla.javascript.SymbolScriptable`

public class XmlRpcObject extends org.mozilla.javascript.BaseFunction
An extension to transparently call and serve XML-RPC from Rhino. The extension adds constructors for XML-RPC clients and servers to the Global Object. All argument conversion is done automatically. Currently the following argument and return types are supported:

- plain objects (with all properties returned by ESObject.getProperties ())
- arrays
- strings
- date objects
- booleans
- integer and float numbers (long values are not supported!)

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.mozilla.javascript.ScriptableObject

`org.mozilla.javascript.ScriptableObject.KeyComparator`

## Field Summary

### Fields inherited from class org.mozilla.javascript.BaseFunction

`Id_arguments, Id_arity, Id_length, Id_name, Id_prototype, MAX_INSTANCE_ID`

### Fields inherited from class org.mozilla.javascript.ScriptableObject

`CONST, DONTENUM, EMPTY, PERMANENT, READONLY, UNINITIALIZED_CONST`

### Fields inherited from interface org.mozilla.javascript.Scriptable

`NOT_FOUND`

## Method Summary

Modifier and Type
Method
Description
`Object`
`call(org.mozilla.javascript.Context cx, org.mozilla.javascript.Scriptable scope, org.mozilla.javascript.Scriptable thisObj, Object[] args)`
`Object`
`get(String name, org.mozilla.javascript.Scriptable start)`
`String`
`getClassName()`
`Object`
`getDefaultValue(Class hint)`
`static void`
`init(org.mozilla.javascript.Scriptable scope)`
Called by the evaluator after the extension is loaded.
`String`
`toString()`
`static Object`
`xmlrpcObjectConstructor(org.mozilla.javascript.Context cx, Object[] args, org.mozilla.javascript.Function ctorObj, boolean inNewExpr)`
This method is used as HopObject constructor from JavaScript.

### Methods inherited from class org.mozilla.javascript.BaseFunction

`construct, createObject, execIdCall, fillConstructorProperties, findInstanceIdInfo, findPrototypeId, getArity, getClassPrototype, getFunctionName, getHomeObject, getInstanceIdName, getInstanceIdValue, getLength, getMaxInstanceId, getPrototypeProperty, getTypeOf, hasDefaultParameters, hasInstance, hasPrototypeProperty, initPrototypeId, isGeneratorFunction, setHomeObject, setImmunePrototypeProperty, setInstanceIdAttributes, setInstanceIdValue, setPrototypeProperty, setPrototypePropertyAttributes, setStandardPropertyAttributes, setupDefaultPrototype`

### Methods inherited from class org.mozilla.javascript.IdScriptableObject

`activatePrototypeMap, addIdFunctionProperty, defaultGet, defaultHas, defaultPut, defineOwnProperty, delete, delete, ensureType, ensureType, exportAsJSClass, findInstanceIdInfo, findPrototypeId, get, getAttributes, getAttributes, getOwnPropertyDescriptor, has, has, hasPrototypeMap, initPrototypeConstructor, initPrototypeMethod, initPrototypeMethod, initPrototypeMethod, initPrototypeValue, initPrototypeValue, instanceIdInfo, put, put, setAttributes`

### Methods inherited from class org.mozilla.javascript.ScriptableObject

`applyDescriptorToAttributeBitset, associateValue, avoidObjectDetection, buildDataDescriptor, callMethod, callMethod, checkPropertyChangeForSlot, checkPropertyDefinition, defineClass, defineClass, defineClass, defineConst, defineConstProperty, defineFunctionProperties, defineOwnProperties, defineOwnProperty, defineProperty, defineProperty, defineProperty, defineProperty, defineProperty, defineProperty, defineProperty, defineProperty, delete, deleteProperty, deleteProperty, deleteProperty, ensureScriptable, ensureScriptableObject, ensureScriptableObjectButNotSymbol, ensureSymbolScriptable, equivalentValues, get, get, getAllIds, getArrayPrototype, getAssociatedValue, getAttributes, getAttributes, getAttributes, getClassPrototype, getDefaultValue, getExternalArrayData, getExternalArrayLength, getFunctionPrototype, getGeneratorFunctionPrototype, getGetterOrSetter, getGetterOrSetter, getIds, getObjectPrototype, getParentScope, getProperty, getProperty, getProperty, getPropertyIds, getPrototype, getSuperProperty, getSuperProperty, getSuperProperty, getTopLevelScope, getTopScopeValue, getTypedProperty, getTypedProperty, has, hasProperty, hasProperty, hasProperty, isAccessorDescriptor, isConst, isDataDescriptor, isEmpty, isExtensible, isFalse, isGenericDescriptor, isGetterOrSetter, isSealed, isTrue, preventExtensions, put, putConst, putConstProperty, putOwnProperty, putOwnProperty, putOwnProperty, putProperty, putProperty, putProperty, putSuperProperty, putSuperProperty, putSuperProperty, querySlot, redefineProperty, sameValue, sealObject, setAttributes, setAttributes, setAttributes, setAttributes, setCommonDescriptorProperties, setExternalArrayData, setGetterOrSetter, setParentScope, setPrototype, size`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.mozilla.javascript.Scriptable

`delete, delete, get, getIds, getParentScope, getPrototype, has, has, put, put, setParentScope, setPrototype`

## Method Details

### xmlrpcObjectConstructor

public static Object xmlrpcObjectConstructor(org.mozilla.javascript.Context cx, Object[] args, org.mozilla.javascript.Function ctorObj, boolean inNewExpr)
This method is used as HopObject constructor from JavaScript.

### init

public static void init(org.mozilla.javascript.Scriptable scope)
Called by the evaluator after the extension is loaded.

### get

public Object get(String name, org.mozilla.javascript.Scriptable start)

Specified by:
  `get` in interface `org.mozilla.javascript.Scriptable`
Overrides:
  `get` in class `org.mozilla.javascript.IdScriptableObject`

### call

public Object call(org.mozilla.javascript.Context cx, org.mozilla.javascript.Scriptable scope, org.mozilla.javascript.Scriptable thisObj, Object[] args) throws org.mozilla.javascript.EvaluatorException

Specified by:
  `call` in interface `org.mozilla.javascript.Callable`
Specified by:
  `call` in interface `org.mozilla.javascript.Function`
Overrides:
  `call` in class `org.mozilla.javascript.BaseFunction`
Throws:
  `org.mozilla.javascript.EvaluatorException`

### getClassName

public String getClassName()

Specified by:
  `getClassName` in interface `org.mozilla.javascript.Scriptable`
Overrides:
  `getClassName` in class `org.mozilla.javascript.BaseFunction`

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getDefaultValue

public Object getDefaultValue(Class hint)

Specified by:
  `getDefaultValue` in interface `org.mozilla.javascript.Scriptable`
Overrides:
  `getDefaultValue` in class `org.mozilla.javascript.ScriptableObject`